function J = egalisation (I)  
    [m, n, can] = size(I); %m=nb lignes, n=nb colonnes, can=nb canaux

    if(can > 1)
        I = rgb2gray(I);  %dans le cas d'une image couleur, la transformer en NG
    end
    %Histogramme :
    histo = zeros(256);   %matrice de zros de taille 256x256 : pour compter les niveaux de gris de 0  255
    for i=1:m             %pour toutes les lignes
        for j=1:n         %pour toutes les colonnes
            histo(I(i,j)+1)= histo(I(i,j)+1)+1;  %+1 car les indices d'une matrice commencent  1 : ne remplit que la premire colonne
        end
    end
    %densit de proba :
    histog2 = ((double(histo)/(m*n)));  %nb entre 0 et 1

    %fonction de rpartition :
    for i=2:256
        histog2(i) = histog2(i) + histog2(i-1);  
    end
    histog2 = histog2 * 255;  %fonction d'egalisation : nb entre 0 et 255
        
    %for i=1:m
    %    for j=1:n
    %        gris = I(i,j)+1;
    %        J(i,j) = uint8(histog2(gris));  %on applique la fonction de rpartition  l'image
    %    end
    %end
    J = uint8(histog2(I+1));  %on applique la fonction de rpartition  l'image

    figure
    imshow(I); 
    %divise la fentre en 3 ligne et 2 colonnes : pour afficher 2 images l'une  ct de l'autre
    subplot(3, 2, 1)  %slectionne le premier cadran 
    colormap(gray)
    image(I);      %affichage de l'image originale
    title(strcat('min = ', num2str(min(min(I))), ' max = ', num2str(max(max(I)))));

    subplot(3, 2, 2) %slectionne le deuxime cadran
    colormap(gray)
    image(J);  
    title(strcat('min = ', num2str(min(min(J))), ' max = ', num2str(max(max(J)))));

    subplot(3, 2, 3) %slectionne le 3me cadran
    plot(imhist(I));

    subplot(3, 2, 4) %slectionne le 4me cadran
    plot(imhist(J));

    subplot(3, 2, 5) %slectionne le 5me cadran
    x = 1:1:255;
    y = histog2(x);
    plot(x,y);
    title('LUT egalisation');
    xlabel('NG entree');
    ylabel('NG sortie');

